<template>
  <div class="dialog" v-if="dialogForm">
    <div class="head_box">
      <span class="title">设备来源范围{{ title }} </span>
      <div>
        <el-button
          type="primary"
          size="small"
          :loading="loading"
          @click="submit"
          >保存</el-button
        >
        <el-button size="small" @click="close">关闭</el-button>
      </div>
    </div>
    <div class="form_cnt">
      <FormMessage
        v-model="listQuery"
        :formList="formData"
        ref="elform"
        :rules="rules"
      >
        <!-- 身份标签细类 -->
        <template #sxtList>
          <el-button @click="openDialog('01')">选择</el-button>
          <div class="boxlist">
            <MyTable
              :tableData="tableDate.sxtList"
              :tableColumn="tableDate.tableColumn"
              :tableHeight="tableDate.tableHeight"
              :key="tableDate.keyCount"
              :tableConfiger="tableDate.tableConfiger"
              :controlsWidth="tableDate.controlsWidth"
            >
              <!-- 操作 -->
              <template #controls="{ row }">
                <el-link
                  type="danger"
                  @click="delDictItem(row.id, '身份标签细类')"
                  >删除</el-link
                >
              </template>
            </MyTable>
          </div>
        </template>
      </FormMessage>
    </div>
    <!-- 列表弹窗 -->
    <DialogList
      :Single="false"
      :roleIds="roleIds"
      v-if="chooseShow"
      :dic="props.dic"
      @chooseDate="chooseDate"
      :titleValue="chooseTitle"
      v-model="chooseShow"
      :bqLx="chooseType"
      bqDl="02"
    ></DialogList>
  </div>
</template>

<script setup>
import MyTable from "@/components/aboutTable/MyTable.vue";
import DialogList from "@/views/backOfficeSystem/BasicManagement/components/dialogList.vue";
import FormMessage from "@/components/aboutTable/FormMessage.vue";
import { qcckGet, qcckPost, qcckPut } from "@/api/qcckApi.js";
import {
  ref,
  defineExpose,
  defineProps,
  reactive,
  defineEmits,
  getCurrentInstance
} from "vue";
const emit = defineEmits(["updateDate"]);
const { proxy } = getCurrentInstance();
const props = defineProps({
  dic: Object
});
const roleIds = ref([]); //角色id
const chooseType = ref("01"); //选择弹窗类型
const chooseShow = ref(false); //选择弹窗
const chooseTitle = ref(""); //选择弹窗
const dialogForm = ref(false); //弹窗
const formData = reactive([
  { label: "集合名称", prop: "jhMc", type: "input" },
  { label: "集合说明", prop: "jhSm", type: "input" },

  { label: "摄像头列表", prop: "sxtList", type: "slot", width: "100%" }
]);
const rules = reactive({
  jhMc: [{ required: true, message: "请输入集合名称", trigger: "blur" }],
  jhSm: [{ required: true, message: "请输入集合说明", trigger: "blur" }]
});

const tableDate = reactive({
  sxtList: [
    {
      csmc: "产商名称",
      csmc: "厂商名称",
      ipdz: "IP地址",
      ipv6dz: "IPV6地址",
      jd: "集合名称",
      jkdbgbh: "监控点国标编号",
      sbbh: "设备编号",
      sbmc: "设备名称",
      sjly: "数据来源",
      sjlyid: "	数据来源ID",
      sxtId: "摄像头ID",
      wd: "地球纬度"
    }
  ], //表格数据
  xwbqIdList: [], //表格数据
  keyCount: 0,
  tableConfiger: {
    rowHieght: 61,
    showSelectType: "null",
    loading: false
  },
  total: 0,
  tableHeight: 225,
  pageConfiger: {
    pageSize: 20,
    pageCurrent: 1
  }, //分页
  controlsWidth: 90, //操作栏宽度
  tableColumn: [
    { label: "产商名称", prop: "csmc", showOverflowTooltip: true },
    { label: "厂商名称", prop: "csmc" },
    { label: "IP地址", prop: "ipdz" },
    { label: "IPV6地址", prop: "ipv6dz" },
    { label: "集合名称", prop: "jd" },
    { label: "监控点国标编号", prop: "jkdbgbh" },
    { label: "设备编号", prop: "sbbh" },
    { label: "设备名称", prop: "sbmc" },
    { label: "数据来源(1 海康 2 旷视)", prop: "sjly" },
    { label: "数据来源ID", prop: "sjlyid" },
    { label: "摄像头ID", prop: "sxtId" },
    { label: "地球纬度", prop: "wd" }
  ]
});
const listQuery = ref({}); //表单
const loading = ref(false);
const elform = ref();
const title = ref("");
// 初始化数据
const init = (type, row) => {
  dialogForm.value = true;
  title.value = type == "add" ? "新增" : "编辑";
  if (row) getDataById(row.id);
};
// 根据id查询详情
const getDataById = (id) => {
  qcckGet({}, "/mosty-gsxt/tbGsxtGzyJh/selectVoById/" + id).then((res) => {
    listQuery.value = res;
    tableDate.sxtList = res.sxtList;
    listQuery.value.sxtList = res.sxtList.map((item) => item.id);
    tableDate.keyCount++;
  });
};

// 提交
const submit = () => {
  elform.value.submit((data) => {
    let url =
      title.value == "新增"
        ? "/mosty-gsxt/tbGsxtGzyJh/save"
        : "/mosty-gsxt/tbGsxtGzyJh/update";
    let params = { ...data };
    params.sxtList = [
      {
        csmc: "产商名称",
        csmc: "厂商名称",
        ipdz: "IP地址",
        ipv6dz: "IPV6地址",
        jd: 29.6510453, //经度
        jkdbgbh: "监控点国标编号",
        sbbh: "设备编号",
        sbmc: "设备名称",
        sjly: "数据来源",
        sjlyid: "	数据来源ID",
        sxtId: "摄像头ID",
        wd: 94.3602321 //维度
      }
    ];
    loading.value = true;
    qcckPost(params, url)
      .then((res) => {
        proxy.$message({ type: "success", message: title.value + "成功" });
        emit("updateDate");
        loading.value = false;
        close();
      })
      .catch(() => {
        loading.value = false;
      });
  });
};
// 打开弹窗
const openDialog = (type) => {
  chooseShow.value = true;
  chooseType.value = type;
  chooseTitle.value = "选择摄像头列表";
  roleIds.value = tableDate.sxtList.map((item) => item.id);
};
// 选择数据
const chooseDate = (data) => {
  if (chooseType.value == "01") {
    tableDate.sxtList = data;
    listQuery.value.sxtList = tableDate.sxtList.map((item) => item.id);
  } else {
    tableDate.xwbqIdList = data;
    listQuery.value.xwbqIdList = tableDate.xwbqIdList.map((item) => item.id);
  }
};

// 删除
const delDictItem = (id, type) => {
  tableDate.sxtList = tableDate.sxtList.filter((item) => item.id !== id);
  listQuery.value.sxtList = tableDate.sxtList.map((item) => item.id);
};
// 关闭
const close = () => {
  listQuery.value = {};
  tableDate.sxtList = [];
  dialogForm.value = false;
  loading.value = false;
};
defineExpose({ init });
</script>

<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.boxlist {
  width: 99%;
  height: 225px;
  margin-top: 10px;
  overflow: hidden;
}
</style>
